//---------------------------------------------------------------------------

#ifndef stringbufferH
#define stringbufferH

/*
   @author    Korniloff E.
   @version   1.00 2007
*/



#include "mytemplate.h"
/*
  DArrayList +    
     ()
*/
class DString{
  public:
    DArray <char> a;

    DString():a(1){
       a[0] = '\0';
    }
    DString(int size):a(size){
       a[0] = '\0';
    }
    DString(const char *s):a(strlen(s)+1){
       strcpy(a.data, s);
    }
    DString (  DString& ds):a(ds.StrLen()+1){
       StrCpy( ds.CStr() );
  
    }
    char* AllocMem( int bytes ) {
      if(a.size < bytes) a[bytes] = 0;
      return CStr();
    }
    int StrLen() { return strlen(a.data); }
    char* StrCpy(const char* s){
      AllocMem( strlen(s) + 1 );
      strcpy(a.data, s);
      return CStr();
    }
    char* StrCat( const char *s ){
      AllocMem( strlen(a.data) + strlen(s) + 1 );
      strcat(a.data, s);
      return CStr();
    }
    int StrCmp( const char *s ){
      return strcmp(a.data, s);
    }
    char*  CStr(){ return a.data; }
    char& operator[] (int i) { return a[i]; }
    DString& operator=(  DString& ds){
       if(this == &ds) return *this;
       StrCpy( ds.CStr() );
       return *this;
    }
      DString& operator=( const char *s){
         StrCpy( s );
         return *this;
      }
    DString& operator += (DString& ds){
       StrCat( ds.CStr() );
       return *this;
    }
       DString& operator += ( const char *s){
         StrCat( s );
         return *this;
      }
    int operator == (DString& ds){
       return StrCmp(ds.CStr())==0;
    }
      int operator == ( const char *s){
         return StrCmp(s)==0;
      }
    char* StrRChr(int c){
      return strrchr( CStr(), c);
    }
    char* StrChr(int c){
      return strchr( CStr(), c);
    }
    char *UpperCase();
    char *LowerCase();

    char* Trim(){
       return ::Trim(a.data);
    }
    char* FGets(FILE *text);
    int FPuts(FILE *text);

};






//---------------------------------------------------------------------------
#endif
